
;;  "Hobbit" wersja polska
;;  Copyright (C) 2005 Pawe Aleksander Fedoryski <pfedor@fuw.edu.pl>
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; either version 2 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


(defvar *jestall*)

(defun szemrane-p (gt-ms)
  (notany #'(lambda (k) (getf gt-ms k)) '(:all :mowc :rz :prz)))

(defun konstr-lob (gt-ms dziedzina mowca &key wymagany-typ rz-prz-jawnie)
  ;(format t "(konstr-lob ~s ~s ~s ~s ~s)~%"
  ;        gt-ms dziedzina mowca wymagany-typ rz-prz-jawnie)
  (if (getf gt-ms :mowc)
      (if (and (or (null wymagany-typ) (eql wymagany-typ :postacie))
               (find mowca dziedzina))
          (list mowca)
          '())
      (remove-if-not
       #'(lambda (id)
           (and (or (null wymagany-typ)
                    (eql (find-type id) wymagany-typ)
                    (and (eql wymagany-typ :postacie) (= id *id-gracz*)))
                (or (null rz-prz-jawnie)
                    (append (getf gt-ms :rz) (getf gt-ms :prz)))
                (or (null (getf gt-ms :rz))
                    (eql (getf (car (getf gt-ms :rz)) :id)
                         (zob :nazwa id)))
                (every #'(lambda (p)
                           (find (getf p :id) (przymiotniki-opisujace id)))
                       (getf gt-ms :prz))
                (or (akceptrodz id (getf gt-ms :rodz))
                    (and (getf gt-ms :all)
                         (eql (getf gt-ms :rodz) :n)))))
       dziedzina)))

(defun nanies-ob (elem id ms)
  ;(format t "(nanies-ob ~s ~s ~s)~%" elem id ms)
  (setf (getf (getf elem ms) :obiekt) id)
  ;(format t "nanies-ob: ~s~%" elem)
  elem)

;; Konstrukcja przy ustalonym wariancie rozbioru i dzialaniu
(defun interp-wr-dzial (gt-elem cowidac dzial mowca)
  ;(format t "(interp-wr-dzial ~s ~s ~s ~s)~%" gt-elem cowidac dzial mowca)
  (let ((acttab `((:dzial ,dzial))))
    (dolist (ms *ms-lista*)
      (let ((gt-ms (getf gt-elem ms))
            (wymagany-typ (zob ms dzial)))
        (when (and gt-ms (null wymagany-typ))
          (return-from interp-wr-dzial '()))
        (when wymagany-typ
          (let* ((szemrane (szemrane-p gt-ms))
                 (all (not (null (getf gt-ms :all))))
                 (lob (konstr-lob gt-ms cowidac mowca
                                  :wymagany-typ wymagany-typ))
                 (oprlob (konstr-lob (getf gt-ms :opr)
                                     lob mowca :rz-prz-jawnie t))
                 (lobbo (set-difference lob oprlob)))
            ;(format t "lob: ~s, oprlob: ~s, lobbo: ~s~%" lob oprlob lobbo)
            (setf acttab
                  (mapcan #'(lambda (id)
                              (mapcar #'(lambda (elem)
                                          (nanies-ob (copy-tree elem) id ms))
                                      acttab))
                          lobbo))
            (setf acttab
                  (mapcar #'(lambda (elem)
                              (when all
                                (setf (getf (getf elem ms) :all) t)
                                (setf *jestall* t))
                              (when szemrane
                                (setf (getf (getf elem ms) :szemr) t))
                              elem)
                          acttab))))))
    (setf acttab
          (mapcar #'(lambda (elem)
                      (setf (getf elem :szemrane)
                            (count-if #'(lambda (ms)
                                          (getf (getf elem ms) :szemr))
                                      *ms-lista*))
                      elem)
                  acttab))
    ;(format t "interp-wr-dzial: ~s~%" acttab)
    acttab))

(defun interp (os gramtab &optional (mowca nil))
  (let ((cytat (getf (cdr gramtab) :cytat))
        (cowidac (co-widzi os))
        (*jestall* nil)
        lw)
    (setf lw (mapcan
              #'(lambda (gt-elem)
                  (let ((dzialania (dzialania-opisywane
                                    (car (getf gt-elem :rozkaz))
                                    (not (null cytat)))))
                    (mapcan
                     #'(lambda (dzial)
                         (interp-wr-dzial gt-elem cowidac dzial mowca))
                     dzialania)))
              (car gramtab)))
    (list lw :cytat cytat :jestall *jestall*)))

