
;;  "Hobbit" wersja polska
;;  Copyright (C) 2005 Pawe Aleksander Fedoryski <pfedor@fuw.edu.pl>
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; either version 2 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


(defparameter *oprocz* "oprcz")
(defparameter *oprprzyp* :dop)

(defparameter *kierunki*
  '(:N "pnoc"
    :S "poudnie"
    :W "zachd"
    :E "wschd"
    :NW "pnocny zachd"
    :NE "pnocny wschd"
    :SW "poudniowy zachd"
    :SE "poudniowy wschd"
    :U "gra"
    :D "d"))

(defparameter *kierunki2*
  '(:N "na pnoc"
    :S "na poudnie"
    :W "na zachd"
    :E "na wschd"
    :NW "na pnocny zachd"
    :NE "na pnocny wschd"
    :SW "na poudniowy zachd"
    :SE "na poudniowy wschd"
    :U "w gr"
    :D "w d"))

(defparameter *kierdrzwi*
  '(:Nd "pnocy"
    :Sd "poudniu"
    :Wd "zachodzie"
    :Ed "wschodzie"
    :NWd "pnocnym zachodzie"
    :NEd "pnocnym wschodzie"
    :SWd "poudniowym zachodzie"
    :SEd "poudniowym wschodzie"
    :Ud "grze"
    :Dd "dole"))

(defparameter *you*
  '(:mian "ty"
    :dop "ci"
    :cel "ci"
    :bier "ci"
    :narz "tob"
    :miejsc "tobie"))

(defparameter *you-long*
  '(:mian "ty"
    :dop "ciebie"
    :cel "tobie"
    :bier "ciebie"
    :narz "tob"
    :miejsc "tobie"))

(defparameter *someone*
  '(:mian "kto"
    :dop "kogo"
    :cel "komu"
    :bier "kogo"
    :narz "kim"
    :miejsc "kim"))

(defparameter *mowca*
  '(:mian "ja"
    :dop "mnie"
    :cel "mi"
    :bier "mnie"
    :narz "mn"
    :miejsc "mnie"))

(defparameter *alln*
  '(:mian "wszystko"
    :dop "wszystkiego"
    :cel "wszystkiemu"
    :bier "wszystko"
    :narz "wszystkim"
    :miejsc "wszystkim"))

(defparameter *allnmos*
  '(:mian "wszystkie"
    :dop "wszystkich"
    :cel "wszystkim"
    :bier "wszystkie"
    :narz "wszystkimi"
    :miejsc "wszystkich"))

(defparameter *allmos*
  '(:mian "wszyscy"
    :dop "wszystkich"
    :cel "wszystkim"
    :bier "wszystkich"
    :narz "wszystkimi"
    :miejsc "wszystkich"))

; Uwaga: nazwy miejsc skladniowych nie moga byc rowne
; :tmp :rozkaz :jakiopr :oprtmp :lastall :dzial :szemrane

(defparameter *ms-przyp*
  '(:obj :bier
    :util :narz
    :komu :cel
    :docel :dop
    :zczego :dop
    :naco :bier
    :przezco :bier
    :wco :bier))

(defparameter *ms-przim*
  '(:docel "do"
    :zczego "z"
    :naco "na"
    :przezco "przez"
    :wco "w"))

(defparameter *opisy-wnetrza*
  '(("w" . ("W ~a" . :miejsc))
    ("pod" . ("Pod ~a" . :narz))
    ("za" . ("Za ~a" . :narz))))

(defparameter *polecenia*
  '(:quit "koniec!"
    :inventory "kiesze"
    :score "punkty"))

(defparameter *kierskr*
  '(("PN" . :N)
    ("PD" . :S)
    ("WS" . :E)
    ("W" . :E)
    ("WSCH" . :E)
    ("ZD" . :W)
    ("Z" . :W)
    ("ZACH" . :W)
    ("PNWS" . :NE)
    ("PNW" . :NE)
    ("PN-WS" . :NE)
    ("PN-W" . :NE)
    ("PN-WSCH" . :NE)
    ("PDWS" . :SE)
    ("PDW" . :SE)
    ("PD-WS" . :SE)
    ("PD-W" . :SE)
    ("PD-WSCH" . :SE)
    ("PNZD" . :NW)
    ("PNZ" . :NW)
    ("PN-ZD" . :NW)
    ("PN-Z" . :NW)
    ("PN-ZACH" . :NW)
    ("PDZD" . :SW)
    ("PDZ" . :SW)
    ("PD-ZD" . :SW)
    ("PD-Z" . :SW)
    ("PD-ZACH" . :SW)
    ("G" . :U)
    ("D" . :D)
    ("GORA" . :U)
    ("DOL" . :D)))

(defparameter *kierzdania*
  '(("id na pnoc" . :N)
    ("id na wschd" . :E)
    ("id na poudnie" . :S)
    ("id na zachd" . :W)
    ("id na pnocny wschd" . :NE)
    ("id na pnocny zachd" . :NW)
    ("id na poudniowy wschd" . :SE)
    ("id na poudniowy zachd" . :SW)
    ("id do gry" . :U)
    ("id w gr" . :U)
    ("id na gr" . :U)
    ("id w d" . :D)
    ("id na d" . :D)
    ("id do dou" . :D)))

(defparameter *zastapienia*
  '(("ze" . "z")
    ("zdejmij" . "zdejm")))

(defun get-const (h k)
  (getf h k))

(defun keys (pl)
  (loop for k on pl by #'cddr collecting (car k)))

(defparameter *przypadki* (keys *you*))
(defparameter *ms-lista* (keys *ms-przyp*))

(defparameter *samogloski* '(#\a #\e #\o #\i #\u #\y #\ #\ #\))

(defun samogloska (c)
  (not (null (find c *samogloski*))))

(defun syczace (slowo)
  (when (notany #'samogloska slowo)
    (return-from syczace nil))
  (unless (find (elt slowo 0) '(#\s #\z #\ #\ #\))
    (return-from syczace nil))
  (when (samogloska (elt slowo 1))
    (return-from syczace nil))
  (unless (eql 2 (mismatch "sz" slowo))
    (return-from syczace t))
  (not (samogloska (elt slowo 2))))

