#!/usr/bin/perl -w

use strict;

use constant CHARACTER_WIDTH => int($ARGV[0]);
use constant NUM_CHARACTERS => int($ARGV[1]);
use constant TABLE_NAME => $ARGV[2];

my $w = NUM_CHARACTERS * CHARACTER_WIDTH;
my $h = 8;

print "\n\nextern unsigned char ".TABLE_NAME."[];\n";
print "unsigned char ".TABLE_NAME."[] = {\n";

my $code;
my $offset;
my $arr;
for my $i (0 .. $w-1) {
        for my $j (0 .. $h-1) {
                $arr->[$i][$j] = 0;
        }
}
while (<STDIN>) {
        if (/(\d+)/) {
                $code = $1;
                $offset = 0;
                next;
        }
        my @a = split //;
        for (my $i = 0; $i < CHARACTER_WIDTH; ++$i) {
                if ($a[$i] eq "#") {
                        my $x = ($code * CHARACTER_WIDTH + $i);
                        my $y = $offset;
                        $arr->[$x][$y] = 1;
                }
        }
        $offset++;
}
for my $i (0 .. NUM_CHARACTERS-1) {
        print "// $i\n";
        for my $j (0 .. $h-1) {
                print "    ";
                for my $k (0 .. CHARACTER_WIDTH-1) {
                        print $arr->[$i * CHARACTER_WIDTH + $k][$j];
                        print ",";
                        print " " if $k != CHARACTER_WIDTH-1;
                }
                print "\n";
        }
}

print "};\n\n";

