
;;  "Hobbit" wersja polska
;;  Copyright (C) 2005 Pawe Aleksander Fedoryski <pfedor@fuw.edu.pl>
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; either version 2 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


(defparameter *zdarzenia*
  '("map-ini"
    "odczepienie-lodzi"
    "kwestia-trolli"
    "drzwi-goblinow"
    "gollum"
    "pierscien"
    "smok-goni"
    "bulbous-eyes"
    "magic-door"
    "beczki-plywaja"
    "portcullis"
    "bagno"
    "pajeczyna"
    "boczne-drzwi"
    "smok-zly"
    "key-shatters"
    "wygrales"))

(defun zdarzenia ()
  (dolist (fn *zdarzenia*)
    (print-description (funcall (intern (string-upcase fn))))))

(defparameter *map-missing*
  #(("longlake" "laketown" :E
     "Id na wschd od Dugiego Jeziora, by dotrze do Miasta na Jeziorze")
    ("mistym" "nplace" :E
     "Id na wschd z Gr Mglistych, by dotrze do wskiego przejcia")
    ("forestgate" "bgplace" :E
     "Id na wschd od bramy do Mrocznej Puszczy, by dotrze do zakltego, ponurego miejsca")
    ("treeless" "oggate" :W
     "Id na zachd z bezdrzewnej polany, by dotrze do zewntrznej strony bramy goblinw")
    ("beorns" "greatriver" :N
     "Id na pnoc z domu Beorna, by dotrze do wielkiej rzeki")))

(defun map-ini ()
  (unless (getf *history* :map-ini)
    (setf (getf *history* :map-ini) t)
    (let* ((i (random (length *map-missing*)))
           (mm (elt *map-missing* i)))
      (setf (getf *history* :map-missing) i)
      (setf (zob (caddr mm) (get-label-id (car mm))) nil)))
  '())

(defun odczepienie-lodzi ()
  (when (not (eql (gdzie *id-gracz*)
                  (car (remove (gdzie (get-label-id "boat"))
                               (list (get-label-id "westbank")
                                     (get-label-id "eastbank"))))))
    (setf (zob :zaczepione (get-label-id "rope")) nil))
  '())

(defun kwestia-trolli ()
  (let ((tj (getf *history* :trolle-jesc))
        (polanka (get-label-id "polanka")))
    (cond
      ((and (null tj)
            (null (getf *history* :trolle-dzien))
            (eql (gdzie *id-gracz*) polanka))
       (setf (getf *history* :trolle-jesc) 3)
       '())
      ((eql 0 tj)
       (dolist (troll (list (get-label-id "htroll")
                            (get-label-id "vtroll")))
         (zabicie troll)
         (setf (gdzie troll) (get-label-id "nigdzie")))
       (setf (zob :dlugiop polanka)
             "Jeste na polanie z dwoma kamiennymi trollami.")
       (setf (zob :anim polanka) "trollsclearingday")
       (setf (zob :visited polanka) nil)
       (setf (getf *history* :trolle-dzien) t)
       (setf (getf *history* :trolle-jesc) nil)
       '("wita dzie."))
      (tj
       (setf (getf *history* :trolle-jesc) (- tj 1))
       '())
      (t
       '()))))

(defun drzwi-goblinow ()
  (let ((otw (zob :otwarte (get-label-id "gobdoor")))
        (otwhist (getf *history* :gobdoor-open)))
    (cond
      ((and otw (not otwhist))
       (setf (getf *history* :gobdoor-open) t))
      ((and otw otwhist)
       (setf (getf *history* :gobdoor-open) nil)
       (setf (zob :otwarte (get-label-id "gobdoor")) nil))
      ((and (not otw) otwhist)
       (setf (getf *history* :gobdoor-open) nil)))
    '()))

(defun gollum ()
  (when (getf *history* :gollum-zabic)
    (if (and (not (eql (kto-pierscien) *id-gracz*))
             (zob :zywy (get-label-id "gollum"))
             (zob :zywy *id-gracz*)
             (not (eql (gdzie *id-gracz*) (get-label-id "gdungeon"))))
        (progn
          (zabicie *id-gracz*)
          (list :ciemno
                "Kto dusi ci od tyu."
                (nie-zyje-info *id-gracz*)))
        (progn
          (setf (getf *history* :gollum-zabic) nil)
          '()))))

(defun pierscien ()
  (let ((ring (get-label-id "ring"))
        (cnt (getf *history* :pierscien-licznik)))
    (when cnt
      (if (> cnt (+ 2 (random 2)))
          (setf (kto-pierscien) nil)
          (setf (getf *history* :pierscien-licznik) (1+ cnt)))))
  '())

(defun bulbous-eyes ()
  (let ((be (getf *history* :bulbous-eyes))
        (be-info "Widzisz blade wyupiaste oczy, wlepione w ciebie."))
    (labels ((be-death ()
               (if (or (not (find (gdzie *id-gracz*)
                                  (mapcar #'get-label-id '("fr2" "fr3"))))
                       (= 0 (random 3)))
                   (progn
                     (zabicie *id-gracz*)
                     (list :ciemno
                           be-info
                           "Co spada z gry i wbija w ciebie do."
                           (nie-zyje-info *id-gracz*)))
                   (list be-info))))
      (cond
        ((not (zob :zywy *id-gracz*))
         '())
        ((null be)
         (cond
           ((eql (gdzie *id-gracz*) (get-label-id "fr2"))
            (setf (getf *history* :bulbous-eyes)
                  '("fr3" "fr3" "fr3" "waterfall"))
            (list be-info))
           ((eql (gdzie *id-gracz*) (get-label-id "fr3"))
            (setf (getf *history* :bulbous-eyes)
                  '("fr2" "fr2" "fr2"  "fr1"))
            (list be-info))
           (t
            '())))
        ((getf *history* :bulbous-eyes-death)
         (be-death))
        ((eql (gdzie *id-gracz*) (get-label-id (car be)))
         (pop (getf *history* :bulbous-eyes))
         (if (not (null (getf *history* :bulbous-eyes)))
             (list be-info)
             (progn
               (setf (getf *history* :bulbous-eyes-death) nil)
               '())))
        (t
         (setf (getf *history* :bulbous-eyes-death) t)
         (be-death))))))

(defun smok-goni ()
  (when (and (getf *history* :smok-zly)
             (zob :zywy (get-label-id "dragon"))
             (zob :zywy *id-gracz*)
             (not (eql (gdzie *id-gracz*) (gdzie (get-label-id "dragon"))))
             (not (zob :ciemno (gdzie *id-gracz*))))
    (cond
      ((null (getf *history* :smok-goni))
       (setf (getf *history* :smok-goni) 1)
       '())
      ((eql 1 (getf *history* :smok-goni))
       (setf (getf *history* :smok-goni) 2)
       '())
      ((= 0 (random 15))
       (progn
         (zabicie *id-gracz*)
         (list
          "Smok obnia lot i w strasznym strumieniu ognia spala ci na popi."
          (nie-zyje-info *id-gracz*))))
      (t
       '("W oddali widzisz ksztat potwornego smoka leccego za tob.")))))

(defun magic-door ()
  (let ((door (get-label-id "magicdoor"))
        (cnt (or (getf *history* :magic-door) 0))
        (mdv (find (gdzie *id-gracz*)
                   (mapcar #'get-label-id '("eclearing" "eghalls")))))
    (cond
      ((zob :otwarte door)
       (setf (zob :otwarte door) nil)
       (when mdv
         '("Magiczne drzwi zamykaj si.")))
      ((> cnt 0)
       (decf cnt)
       (setf (getf *history* :magic-door) cnt)
       (when (= 0 cnt)
         (setf (zob :otwarte door) t)
         (when mdv
           '("Magiczne drzwi otwieraj si."
             "Przebiega elf."))))
      (t
       '()))))

(defun beczki-plywaja ()
  (let ((barrel (get-label-id "barrel"))
        (longlake (get-label-id "longlake"))
        (opis '()))
    (cond
      ((not (eql (gdzie barrel) (get-label-id "forestriver2")))
       '())
      ((not (getf *history* :beczka-w-rzece))
       (setf (getf *history* :beczka-w-rzece) t)
       '())
      (t
       (remf *history* :beczka-w-rzece)
       (setf (gdzie barrel) longlake)
       (setf (zob :otwarte barrel) t)
       (when (eql (gdzie *id-gracz* :stop barrel) barrel)
         (setf opis
               (append '("Rzeka wyrzuca ci na brzeg Dugiego Jeziora.")
                       (desc-location longlake))))
       (dolist (id (append (przedmioty-wewnatrz barrel)
                           (postacie-wewnatrz barrel)
                           (when (eql barrel (zob :gdzie_prz *id-gracz*))
                             (list *id-gracz*))))
         (setf (gdzie id) longlake))
       (setf (gdzie barrel) (get-label-id "cellar"))
       (setf (gdzie (get-label-id "wine")) barrel)
       (setf (zob :otwarte barrel) nil)
       opis))))

(defun portcullis ()
  (cond
    ((eql (gdzie *id-gracz* :stop :przedmiot) (get-label-id "forestriver2"))
     (zabicie *id-gracz*)
     (list "Prd z ogromn si rzuca ci na krat."
           (nie-zyje-info *id-gracz*)))
    (t
     '())))

(defun bagno ()
  (cond
    ((and (eql (gdzie *id-gracz*) (get-label-id "bog"))
          (zob :zywy *id-gracz*))
     (zabicie *id-gracz*)
     (list "Powoli zanurzasz si w bagnie."
           (nie-zyje-info *id-gracz*)))
    (t
     '())))

(defun pajeczyna ()
  (cond
    ((not (zob :zywy *id-gracz*))
     '())
    ((getf *history* :broken-web)
     (decf (getf *history* :broken-web))
     (when (eql 0 (getf *history* :broken-web))
       (setf (getf *history* :broken-web) nil)
       (setf (zob :rozbite (get-label-id "web")) nil)
       (setf (przymiotniki-opisujace (get-label-id "web")) '()))
     '())
    ((eql (gdzie *id-gracz*) (get-label-id "spiderplace"))
     (if (getf *history* :killing-web)
         (progn
           (decf (getf *history* :killing-web))
           (when (eql 0 (getf *history* :killing-web))
             (zabicie *id-gracz*)
             (list "Pajczyna powoli ci dusi."
                   (nie-zyje-info *id-gracz*))))
         (progn
           (setf (getf *history* :killing-web)
                 (+ 3 (random 3)))
           '())))
    (t
     '())))

(defun boczne-drzwi ()
  (let ((door (get-label-id "sidedoordoor"))
        (lok (get-label-id "sidedoor"))
        (ssp (get-label-id "smoothstraightpassage")))
    (cond
      ((and (null (getf *history* :sidedoor-counting))
            (not (getf *history* :sidedoor-installed))
            (eql (gdzie *id-gracz*) lok))
       (setf (getf *history* :sidedoor-counting) 1)
       '())
      ((not (null (getf *history* :sidedoor-counting)))
       (incf (getf *history* :sidedoor-counting))
       (when (= 4 (getf *history* :sidedoor-counting))
         (setf (zob :Ed lok) door
               (zob :Wd ssp) door
               (zob :otwarte door) nil
               (zob :locked door) t
               (getf *history* :sidedoor-counting) nil
               (getf *history* :sidedoor-installed) t)
         (when (eql (gdzie *id-gracz*) lok)
           '("Sycha gony trzask i na wysokoci okoo trzech stp pojawia si dziura." "Stoisz przed bocznym wejciem do Samotnej Gry."))))
      ((and (getf *history* :sidedoor-installed)
            (not (zob :otwarte door)))
       (setf (zob :Ed lok) nil
             (zob :Wd ssp) nil
             (getf *history* :sidedoor-installed) nil)
       (when (or (eql (gdzie *id-gracz*) lok)
                 (eql (gdzie *id-gracz*) ssp))
         '("Dziura znika."))))))

(defun smok-zly ()
  (when (or (eql (gdzie (get-label-id "treasure") :stop :os) *id-gracz*)
            (eql (gdzie *id-gracz*) (get-label-id "lowerhalls")))
    (setf (getf *history* :smok-zly) t))
  '())

(defun key-shatters ()
  (let* ((sck (get-label-id "smallcuriouskey"))
         (desc (lfn "~a pka." (mian sck :poczatek-zdania t))))
    (when (and (not (zob :zywy (get-label-id "thorin")))
               (not (zob :zlamane sck)))
      (polamanie sck)
      (when (eql (gdzie *id-gracz*) (gdzie sck))
        desc))))

(defun wygrales ()
  (when (and (eql (gdzie (get-label-id "treasure") :stop :przedmiot)
                  (get-label-id "chest"))
             (zob :zywy *id-gracz*))
    (setf (getf *history* :wygrales) t)
    '(""
      "Pojawia si wiwatujcy tum krasnoludw, hobbitw i elfw. Z Gandalfem na czele, unosz ci w stron zachodzcego soca, ogaszajc najwikszym bohaterem!!!")))
